This is luac, the Lua compiler.
There are man pages for it in both nroff and html in ../../doc.

luac translates Lua programs into binary files that can be loaded latter.
The main advantages of pre-compiling chunks are: faster loading, protecting
source code from user changes, and off-line syntax error detection.
luac can also be used to learn about the Lua virtual machine.

Usage: /l/luac/luac [options] [filenames].  Available options are:
  -        process stdin
  -l       list
  -o name  output to file `name' (default is "luac.out")
  -p       parse only
  -s       strip debug information
  -v       show version information
  --       stop handling options

luac is also an example of how to use the internals of Lua (politely).
